Index: binaries/data/mods/public/simulation/components/Player.js
===================================================================
--- binaries/data/mods/public/simulation/components/Player.js	(revision 15299)
+++ binaries/data/mods/public/simulation/components/Player.js	(working copy)
@@ -36,6 +36,7 @@
 	this.cheatsEnabled = false;
 	this.cheatTimeMultiplier = 1;
 	this.heroes = [];
+	this.trainableUnits = {};
 	this.resourceNames = {
 		"food": markForTranslation("Food"),
 		"wood": markForTranslation("Wood"),
@@ -464,6 +465,16 @@
 	this.formations = formations;
 };
 
+Player.prototype.GetTrainableUnits = function()
+{
+	return this.trainableUnits;
+};
+
+Player.prototype.SetTrainableUnits = function(units)
+{
+	this.trainableUnits = units;
+};
+
 Player.prototype.GetStartingCameraPos = function()
 {
 	return this.startCam.position;
Index: binaries/data/mods/public/simulation/components/ProductionQueue.js
===================================================================
--- binaries/data/mods/public/simulation/components/ProductionQueue.js	(revision 15299)
+++ binaries/data/mods/public/simulation/components/ProductionQueue.js	(working copy)
@@ -15,7 +15,12 @@
 		"<ref name='nonNegativeDecimal'/>" +
 	"</element>" +
 	"<optional>" + 
-		"<element name='Entities' a:help='Space-separated list of entity template names that this building can train. The special string \"{civ}\" will be automatically replaced by the building&apos;s four-character civ code'>" +
+		"<element name='TrainFromJSON' a:help='Set to \"true\" in order to add all entities defined in the civ JSON.'>" +
+			"<text/>" +
+		"</element>" +
+	"</optional>" + 
+	"<optional>" + 
+		"<element name='Entities' a:help='Space-separated list of entity template names that this building can train (in addition to the training group). The special string \"{civ}\" will be automatically replaced by the building&apos;s four-character civ code'>" +
 			"<attribute name='datatype'>" +
 				"<value>tokens</value>" +
 			"</attribute>" +
@@ -23,6 +28,22 @@
 		"</element>" +
 	"</optional>" + 
 	"<optional>" + 
+		"<element name='RequiredClasses' a:help='Require certain classes from the trainable entities'>" +
+			"<attribute name='datatype'>" +
+				"<value>tokens</value>" +
+			"</attribute>" +
+			"<text/>" +
+		"</element>" +
+	"</optional>" + 
+	"<optional>" + 
+		"<element name='ForbiddenClasses' a:help='Forbid certain classes from the trainable entities'>" +
+			"<attribute name='datatype'>" +
+				"<value>tokens</value>" +
+			"</attribute>" +
+			"<text/>" +
+		"</element>" +
+	"</optional>" + 
+	"<optional>" + 
 		"<element name='Technologies' a:help='Space-separated list of technology names that this building can research.'>" +
 			"<attribute name='datatype'>" +
 				"<value>tokens</value>" +
@@ -67,6 +88,12 @@
 	this.spawnNotified = false;
 	
 	this.alertRaiser = undefined;
+
+	// Hack for atlas, where the player settings are only set when the game starts
+	// so update the entities and technologies on the first turn
+	var cmpTimer = Engine.QueryInterface(SYSTEM_ENTITY, IID_Timer);
+	cmpTimer.SetTimeout(this.entity, IID_ProductionQueue, "CalculateEntitiesList", 1, {});
+	cmpTimer.SetTimeout(this.entity, IID_ProductionQueue, "CalculateTechnologiesList", 1, {});
 };
 
 ProductionQueue.prototype.PutUnderAlert = function(raiser)
@@ -90,22 +117,33 @@
 ProductionQueue.prototype.CalculateEntitiesList = function()
 {
 	this.entitiesList = [];
-	if (!this.template.Entities)
+	var cmpPlayer = QueryOwnerInterface(this.entity, IID_Player);
+	var cmpIdentity = Engine.QueryInterface(this.entity, IID_Identity);
+	if (!cmpIdentity || !cmpPlayer || cmpPlayer.GetPlayerID() == 0)
 		return;
-	
-	var string = this.template.Entities._string;
-	if (!string)
-		return;
-	
-	// Replace the "{civ}" codes with this entity's civ ID
-	var cmpIdentity = Engine.QueryInterface(this.entity, IID_Identity);
-	if (cmpIdentity)
-		string = string.replace(/\{civ\}/g, cmpIdentity.GetCiv());
-	
-	var entitiesList = string.split(/\s+/);
 
-	// check if some templates need to show their advanced or elite version
-	var upgradeTemplate = function(templateName)
+	// temporary variable to work with
+	var ents = [];
+	// add the entities defined in the template
+	if (this.template.Entities && this.template.Entities._string)
+		ents = ents.concat(this.template.Entities._string.split(/\s+/));
+
+	// add the entities defined in the civ.json
+	if (this.template.TrainFromJSON && this.template.TrainFromJSON == "true")
+		ents = ents.concat(cmpPlayer.GetTrainableUnits());
+
+	var cmpTemplateManager = Engine.QueryInterface(SYSTEM_ENTITY, IID_TemplateManager);
+	var playerID = cmpPlayer.GetPlayerID();
+
+	var requiredClasses, forbiddenClasses;
+	if (this.template.RequiredClasses)
+		requiredClasses = this.template.RequiredClasses._string;
+	if (this.template.ForbiddenClasses)
+		forbiddenClasses = this.template.ForbiddenClasses._string;
+
+	// function to check if some templates need to show their advanced or elite version
+	// Also filters the entities already in the list based on their classes
+	var upgradeAndFilterTemplate = function(templateName)
 	{
 		var template = cmpTemplateManager.GetTemplate(templateName);
 		while (template && template.Promotion !== undefined)
@@ -116,17 +154,32 @@
 			templateName = template.Promotion.Entity;
 			template = cmpTemplateManager.GetTemplate(templateName);
 		}
+		if (!template || !template.Identity)
+			return null;
+		var classes = GetIdentityClasses(template.Identity);
+		if (requiredClasses && !MatchesClassList(classes, requiredClasses))
+			return null;
+		if (forbiddenClasses && MatchesClassList(classes, requiredClasses))
+			return null;
 		return templateName;
 	};
 
-	var cmpTemplateManager = Engine.QueryInterface(SYSTEM_ENTITY, IID_TemplateManager);
-	var playerID = QueryOwnerInterface(this.entity, IID_Player).GetPlayerID();
-	for each (var templateName in entitiesList)
-		this.entitiesList.push(upgradeTemplate(templateName));
-	for each (var item in this.queue)
+	for (var i = 0; i <  ents.length; i++)
 	{
+		var templateName = ents[i].replace(/\{civ\}/g, cmpPlayer.GetCiv());
+		templateName = upgradeAndFilterTemplate(templateName);
+		if (templateName)
+			this.entitiesList.push(templateName);
+	}
+	// also update the queue, to produce more advanced units in case they should be upgraded now
+	for (var item of this.queue)
+	{
 		if (item.unitTemplate)
-			item.unitTemplate = upgradeTemplate(item.unitTemplate);
+		{
+			var templateName = upgradeAndFilterTemplate(item.unitTemplate);
+			if (templateName)
+				item.unitTemplate = templateName;
+		}
 	}
 };
 
@@ -135,16 +188,22 @@
  */
 ProductionQueue.prototype.GetTechnologiesList = function()
 {
+	return this.technologiesList
+};
+
+ProductionQueue.prototype.CalculateTechnologiesList = function()
+{
+	this.technologiesList = [];
 	if (!this.template.Technologies)
-		return [];
+		return;
 	
 	var string = this.template.Technologies._string;
 	if (!string)
-		return [];
+		return;
 	
 	var cmpTechnologyManager = QueryOwnerInterface(this.entity, IID_TechnologyManager);
 	if (!cmpTechnologyManager)
-		return [];
+		return;
 	
 	var techs = string.split(/\s+/);
 	var techList = [];
@@ -174,8 +233,6 @@
 		techList[i] = tech;
 	}
 	
-	var ret = []
-	
 	// This inserts the techs into the correct positions to line up the technology pairs
 	for (var i = 0; i < techList.length; i++)
 	{
@@ -182,18 +239,16 @@
 		var tech = techList[i];
 		if (!tech)
 		{
-			ret[i] = undefined;
+			this.technologiesList[i] = undefined;
 			continue;
 		}
 		
 		var template = cmpTechnologyManager.GetTechnologyTemplate(tech);
 		if (template.top)
-			ret[i] = {"pair": true, "top": template.top, "bottom": template.bottom};
+			this.technologiesList[i] = {"pair": true, "top": template.top, "bottom": template.bottom};
 		else
-			ret[i] = tech;
+			this.technologiesList[i] = tech;
 	}
-	
-	return ret;
 };
 
 ProductionQueue.prototype.IsTechnologyResearchedOrInProgress = function(tech)
@@ -324,6 +379,7 @@
 				"timeTotal": time*1000,
 				"timeRemaining": time*1000,
 			});
+			this.CalculateTechnologiesList();
 		}
 		else
 		{
@@ -406,6 +462,7 @@
 			// item.player is used as this.entity's owner may be invalid (deletion, etc.)
 			var cmpTechnologyManager = QueryPlayerIDInterface(item.player, IID_TechnologyManager);
 			cmpTechnologyManager.StoppedResearch(item.technologyTemplate);
+			this.CalculateTechnologiesList();
 		}
 		
 		// Remove from the queue
@@ -474,7 +531,10 @@
 			cmpPlayer.UnBlockTraining();
 	}
 	if (msg.to != -1)
+	{
 		this.CalculateEntitiesList();
+		this.CalculateTechnologiesList();
+	}
 
 	// Reset the production queue whenever the owner changes.
 	// (This should prevent players getting surprised when they capture
@@ -774,4 +834,9 @@
 		this.CalculateEntitiesList();
 };
 
+ProductionQueue.prototype.OnGlobalTemplateModification = function()
+{
+	this.CalculateTechnologiesList();
+};
+
 Engine.RegisterComponentType(IID_ProductionQueue, "ProductionQueue", ProductionQueue);
Index: binaries/data/mods/public/simulation/helpers/Player.js
===================================================================
--- binaries/data/mods/public/simulation/helpers/Player.js	(revision 15299)
+++ binaries/data/mods/public/simulation/helpers/Player.js	(working copy)
@@ -123,6 +123,17 @@
 				cmpPlayer.SetFormations(rawFormations.Formations);
 			}
 
+			var trainableUnits = getSetting(pData, pDefs, "TrainableUnits");
+			if (trainableUnits !== undefined)
+				cmpPlayer.SetTrainableUnits(trainableUnits);
+			else
+			{
+				var data = Engine.ReadCivJSONFile(cmpPlayer.GetCiv()+".json");
+				if (data && data.TrainableUnits)
+					cmpPlayer.SetTrainableUnits(data.TrainableUnits);
+			}
+
+
 			var startCam = getSetting(pData, pDefs, "StartingCamera");
 			if (startCam !== undefined)
 				cmpPlayer.SetStartingCamera(startCam.Position, startCam.Rotation);
